<template>
  <div class="upload-file">
    <el-upload
      :action="uploadFileUrl"
      :disabled="disabled"
      :before-upload="handleBeforeUpload"
      :limit="limit"
      :fileType="fileType"
      :list-type="listType"
      :on-error="handleUploadError"
      :on-exceed="handleExceed"
      :on-success="handleUploadSuccess"
      :on-change="fileChange"
      :show-file-list="false"
      :headers="headers"
      class="upload-file-uploader"
      :class="{ hide: fileArr.length > 0 || addShow }"
      ref="upload"
      multiple
    >
      <!-- 上传按钮 -->
      <el-button :disabled="disabled"  plain type="primary">选取文件</el-button>
      <!--<i class="el-icon-plus"></i>-->
      <!-- 上传提示 -->
      <div class="el-upload__tip" slot="tip" v-if="showTip">
        请上传
        <template v-if="fileSize">
          大小不超过 <b style="color: #f56c6c">{{ fileSize }}MB</b>
        </template>
        <template v-if="fileType">
          格式为 <b style="color: #f56c6c">{{ fileType.join("/") }}</b>
        </template>
        的文件，且不超过{{limit}}个
      </div>
    </el-upload>

    <div class="video-list">
      <div
        class="video-box"
        v-for="(item,index) in fileArr"
      >
        <video
          type="video/mp4"
          controls="controls"
          :src="item"
          class="upload-video"
        />
        <i class="el-icon-close video-close" @click="removeVideo(index)"></i>
      </div>
    </div>
  </div>
</template>

<script>
  import { getToken } from "@/utils/auth";

  export default {
    props: {
      // 值
      value: [String, Object, Array],
      listType: {
        type: String,
        defaule: "text",
      },
      // 大小限制(MB)
      fileSize: {
        type: Number,
        default: 50,
      },
      fileArr: {
        type: Array,
        default: [],
      },
      // 文件类型, 例如['png', 'jpg', 'jpeg']
      fileType: {
        type: Array,
        default: () => ["doc", "xls", "ppt", "txt", "pdf"],
      },
      limit: {
        type: Number,
        default: 5
      },
    // 是否显示提示
    isShowTip: {
      type: Boolean,
      default: true,
    },
    disabled: {
      type: Boolean,
      default:false,
    },
  },
    data() {
      return {
        uploadFileUrl: process.env.VUE_APP_BASE_API + "/common/upload", // 上传的图片服务器地址
        headers: {
          Authorization: "Bearer " + getToken(),
        },
        fileList: [],
        modal: false,
        dialogVisible: false,
        dialogImageUrl: "",
        addShow: true,
        totalNum: 0
      };
    },
    computed: {
      // 是否显示提示
      showTip() {
        return this.isShowTip && (this.fileType || this.fileSize);
      },
      bigImageArr() {
        return [this.dialogImageUrl];
      },
    },
    methods: {
      // 上传前校检格式和大小
      handleBeforeUpload(file) {
        // 校检文件类型
        if (this.fileType) {
          let fileExtension = "";
          if (file.name.lastIndexOf(".") > -1) {
            fileExtension = file.name.slice(file.name.lastIndexOf(".") + 1);
          }
          const isTypeOk = this.fileType.some((type) => {
            if (file.type.indexOf(type) > -1) return true;
          if (fileExtension && fileExtension.indexOf(type) > -1) return true;
          return false;
        });
          if (!isTypeOk) {
            this.$message.error(
              `文件格式不正确, 请上传${this.fileType.join("/")}格式文件!`
            );
            return false;
          }
        }
        // 校检文件大小
        if (this.fileSize) {
          const isLt = file.size / 1024 / 1024 < this.fileSize;
          if (!isLt) {
            this.$message.error(`上传文件大小不能超过 ${this.fileSize} MB!`);
            return false;
          }
        }
        this.totalNum++;
        if(this.totalNum > this.limit){
          this.$message.error('只允许上传'+ this.limit +'个文件');
          return false;
        }
        return true;
      },
      // 文件个数超出
      handleExceed() {
        this.$message.error('只允许上传'+ this.limit +'个文件');
      },
      // 上传失败
      handleUploadError(err) {
        this.$message.error("上传失败, 请重试");
      },
      // 上传成功回调
      handleUploadSuccess(res) {
        if (res.code == 200) {
          this.$emit('resFun', res);
          this.$message.success("上传成功");
        } else {
          this.$message({ message: res.msg, type: 'error', duration: 1500 })
        }
      },
      removeVideo(index){
        this.$emit("remove", index);
      },
      handleFileClick(file, fileList) {
        this.dialogImageUrl = file.response ? file.response.url : file.url;
        //  this.dialogImageUrl =if(this.fileArr) this.fileArr[0].url;

        // this.dialogVisible = true;
        this.$refs.previewImg.showViewer = false;

        console.log(file);
        // console.log(file.response.url)
      },
      // 当改变列表改变时
      fileChange(file, fileList) {
        this.addShow = fileList.length > 0 ? true : false;
      },
    },
    created() {
      console.log(this.fileArr);
      this.addShow = this.fileArr.length > 0 ? true : false;
      this.totalNum = this.fileArr.length;
    },
  };
</script>

<style scoped lang="scss">
  img {
    width: 100%;
  }
  .upload-file-uploader {
    margin-bottom: 5px;
  }
  .upload-file-list .el-upload-list__item {
    border: 1px solid #e4e7ed;
    line-height: 2;
    margin-bottom: 10px;
    position: relative;
  }
  .upload-file-list .ele-upload-list__item-content {
    display: flex;
    justify-content: space-between;
    align-items: center;
    color: inherit;
  }
  .ele-upload-list__item-content-action .el-link {
    margin-right: 10px;
  }

  .video-list{
    display: flex;
    flex-direction: row;
    flex-wrap:wrap
  }

  .video-box{
    padding: 2px;
    width: 48%;
    position: relative
  }
  .upload-video{
    object-fit:fill;
    height: 180px;
    width: 100%
  }

  .video-close{
    line-height: 26px;
    position: absolute;
    right: 8px;
    top: 8px;
    font-size: 20px;
    cursor: pointer;
  }
</style>
